Package: alabaster.ranges
Title: Load and Save Ranges-related Artifacts from File
Version: 1.12.0
Date: 2025-07-22
Authors@R: person("Aaron", "Lun", role=c("aut", "cre"), email="infinite.monkeys.with.keyboards@gmail.com")
License: MIT + file LICENSE
Description: 
    Save GenomicRanges, IRanges and related data structures into file artifacts, and load them back into memory.
    This is a more portable alternative to serialization of such objects into RDS files.
    Each artifact is associated with metadata for further interpretation;
    downstream applications can enrich this metadata with context-specific properties.
Depends: GenomicRanges, alabaster.base
Imports: methods, S4Vectors, BiocGenerics, IRanges, Seqinfo, rhdf5
Suggests: testthat, knitr, BiocStyle, jsonlite
VignetteBuilder: knitr
RoxygenNote: 7.2.3
biocViews: DataImport, DataRepresentation
git_url: https://git.bioconductor.org/packages/alabaster.ranges
git_branch: RELEASE_3_23
git_last_commit: 7941158
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 20:33:17 UTC; biocbuild
Author: Aaron Lun [aut, cre]
Maintainer: Aaron Lun <infinite.monkeys.with.keyboards@gmail.com>

#' Read a GRangesList from disk
#'
#' Read a \linkS4class{GRangesList} object from its on-disk representation.
#' 
#' @param path String containing a path to a directory, itself created with the \code{\link{saveObject}} method for \linkS4class{GRangesList}s.
#' @param metadata Named list of metadata for this object, see \code{\link{readObjectFile}} for details.
#' @param ... Further arguments, to be passed to internal \code{\link{altReadObject}} calls.
#'
#' @return A \linkS4class{GRangesList} object.
#'
#' @examples
#' gr <- GRanges(c("chrA", "chrB"), IRanges(c(1, 5), c(100, 200)))
#' seqlengths(gr) <- c(chrA=1000, chrB=2000)
#' grl <- split(gr, rep(1:3, length.out=length(gr)))
#'
#' tmp <- tempfile()
#' saveObject(grl, tmp)
#' readObject(tmp)
#' 
#' @export
#' @aliases loadGRangesList
readGRangesList <- function(path, metadata, ...) {
    .read_compressed_list(path, metadata, "genomic_ranges_list", ...)
}

##############################
######### OLD STUFF ##########
##############################

#' @export
loadGRangesList <- function(info, project) {
    concat.info <- acquireMetadata(project, info$genomic_ranges_list$concatenated$resource$path)
    concat <- .loadObject(concat.info, project=project)
    .load_compressed(concat, info, project)
}

# Test stageGRanges on various bits and pieces.
# library(testthat); library(alabaster.ranges); source("setup.R"); source("test-GRangesList.R")

set.seed(1000)
gr <- GRanges(
    paste0('chr', sample(LETTERS[1:3], 100, replace=TRUE)),
    IRanges(sample(1000, 100), width=sample(100, 100, replace=TRUE)),
    strand=sample(c("+", "-", "*"), 100, replace=TRUE)
)
names(gr) <- paste0("Exon_", seq_along(gr))

grl <- splitAsList(gr, sample(length(gr), 100, replace=TRUE))
names(grl) <- paste0("Gene_", seq_along(grl))

test_that("stageObject works correctly", {
    tmp <- tempfile()
    dir.create(tmp)

    grlmeta <- .validatedStage(grl, tmp, "grl")
    expect_true(grlmeta$compressed_list$names)
    .writeMetadata(grlmeta, tmp)

    expect_null(grlmeta$compressed_list$element_data) # no metadata yet
    expect_null(grlmeta$compressed_list$other_data) 
    expect_identical(grlmeta$compressed_list$compression, "gzip")

    # Coordinate information is saved correctly. 
    grmeta <- jsonlite::fromJSON(file.path(tmp, paste0(grlmeta$genomic_ranges_list$concatenated$resource$path, ".json")), simplifyVector=FALSE)
    expect_true(grmeta$genomic_ranges$names)

    grouping <- read.csv(file.path(tmp, grlmeta$path), row.names=1)
    expect_false(is.null(grouping$number))
    expect_identical(rownames(grouping), names(grl))

    # Round trip works.
    grl2 <- loadGRangesList(grlmeta, tmp)
    expect_identical(grl2, grl)

    # Works in the new world.
    tmp2 <- tempfile()
    saveObject(grl, tmp2)
    expect_identical(grl, readObject(tmp2))
})

test_that("stageObject handles its own metadata", {
    mcols(grl)$stuff <- sample(LETTERS, length(grl), replace=TRUE)

    tmp <- tempfile()
    dir.create(tmp)
    grlmeta <- .validatedStage(grl, tmp, "grl")
    expect_false(is.null(grlmeta$compressed_list$element_data))

    emeta <- jsonlite::fromJSON(file.path(tmp, paste0(grlmeta$compressed_list$element_data$resource$path, ".json")), simplifyVector=FALSE)
    expect_identical(length(emeta$data_frame$columns), 1L)

    grl2 <- loadGRangesList(grlmeta, tmp)
    expect_identical(grl2, grl)

    # Works in the new world.
    tmp2 <- tempfile()
    saveObject(grl, tmp2)
    expect_identical(grl, readObject(tmp2))

    # Ignoring them.
    out <- stageObject(grl, tmp, "nomcols", mcols.name=NULL)
    expect_null(out$compressed_list$element_data)

    grl3 <- loadGRangesList(out, tmp)
    expect_identical(ncol(mcols(grl3)), 0L)
})

test_that("stageObject handles GRLs with internal metadata", {
    tmp <- tempfile()
    dir.create(tmp)

    mcols(grl@unlistData)$stuff <- rpois(length(grl@unlistData), lambda=5)
    grlmeta <- .validatedStage(grl, tmp, "grl")

    # Coordinate information is saved correctly. 
    cat.path <- grlmeta$genomic_ranges_list$concatenated$resource$path
    grmeta <- jsonlite::fromJSON(file.path(tmp, paste0(cat.path, ".json")), simplifyVector=FALSE)
    grdf <- read.csv(file.path(tmp, grmeta$genomic_ranges$range_data$resource$path))
    expect_identical(grdf$stuff, unlist(grl)$stuff)

    # Round trip works correctly.
    grl2 <- loadGRangesList(grlmeta, tmp)
    expect_identical(grl2, grl)

    # Works in the new world.
    tmp2 <- tempfile()
    saveObject(grl, tmp2)
    expect_identical(grl, readObject(tmp2))
})

test_that("stageObject handles unnamed GRLs", {
    tmp <- tempfile()
    dir.create(tmp)

    names(grl@unlistData) <- NULL
    names(grl) <- NULL

    grlmeta <- .validatedStage(grl, tmp, "grl")
    expect_false(grlmeta$compressed_list$names)
    grmeta <- jsonlite::fromJSON(file.path(tmp, paste0(grlmeta$genomic_ranges_list$concatenated$resource$path, ".json")), simplifyVector=FALSE)
    expect_false(grmeta$genomic_ranges$names)

    # Round trip works.
    grl2 <- loadGRangesList(grlmeta, tmp)
    expect_identical(grl2, grl)

    # Works in the new world.
    tmp2 <- tempfile()
    saveObject(grl, tmp2)
    expect_identical(grl, readObject(tmp2))
})

test_that("stageObject handles empty GRLs", {
    tmp <- tempfile()
    dir.create(tmp)

    copy <- GRangesList(rep(list(GRanges()), 100))
    names(copy) <- seq_len(100)

    grlmeta <- .validatedStage(copy, tmp, "grl")

    grl2 <- loadGRangesList(grlmeta, tmp)
    expect_identical(grl2, copy)

    # Works in the new world.
    tmp2 <- tempfile()
    saveObject(grl, tmp2)
    expect_identical(grl, readObject(tmp2))
})

test_that("stageObject works with extra metadata", {
    metadata(grl) <- list(WHEE="foo")

    tmp <- tempfile()
    dir.create(tmp)
    out <- .validatedStage(grl, tmp, "thing")
    expect_false(is.null(out$compressed_list$other_data))

    grl2 <- loadGRangesList(out, tmp)
    expect_equal(grl, grl2)

    # Works in the new world.
    tmp2 <- tempfile()
    saveObject(grl, tmp2)
    expect_identical(grl, readObject(tmp2))

    # Ignoring them.
    out <- stageObject(grl, tmp, "nometa", meta.name=NULL)
    expect_null(out$compressed_list$other_data)

    grl3 <- loadGRangesList(out, tmp)
    expect_identical(length(metadata(grl3)), 0L)
})

.onLoad <- function(libname, pkgname) {
    registerReadObjectFunction("sequence_information", readSeqinfo)
    registerReadObjectFunction("genomic_ranges", readGRanges)
    registerReadObjectFunction("atomic_vector_list", readAtomicVectorList)
    registerReadObjectFunction("data_frame_list", readDataFrameList)
    registerReadObjectFunction("genomic_ranges_list", readGRangesList)
}

.onUnload <- function(libname, pkgname) {
    registerReadObjectFunction("sequence_information", NULL)
    registerReadObjectFunction("genomic_ranges", NULL)
    registerReadObjectFunction("atomic_vector_list", NULL)
    registerReadObjectFunction("data_frame_list", NULL)
    registerReadObjectFunction("genomic_ranges_list", NULL)
}

#' Save compressed list of atomic vectors to disk
#'
#' Save a \linkS4class{CompressedAtomicList} object to its on-disk representation.
#'
#' @param x A \linkS4class{CompressedAtomicList} object.
#' @inheritParams alabaster.base::saveObject
#'
#' @return 
#' \code{x} is saved to \code{path}, and \code{NULL} is invisibly returned.
#'
#' @seealso
#' \code{\link{readAtomicVectorList}}, to read a \linkS4class{CompressedAtomicList} from disk.
#'
#' @author Aaron Lun
#' @examples
#' library(S4Vectors)
#' X <- splitAsList(LETTERS, sample(3, 26, replace=TRUE))
#'
#' tmp <- tempfile()
#' saveObject(X, tmp)
#' list.files(tmp, recursive=TRUE)
#'
#' @export
#' @aliases stageObject,CompressedAtomicList-method
#' @rdname saveAtomicVectorList
setMethod("saveObject", "CompressedAtomicList", function(x, path, ...) .save_compressed_list(x, path=path, name="atomic_vector_list", ...))

#' @import BiocGenerics IRanges rhdf5 alabaster.base
.save_compressed_list <- function(x, path, name, ...) {
    dir.create(path, showWarnings=FALSE)
    altSaveObject(unlist(x, use.names=FALSE), file.path(path, "concatenated"), ...)
    saveMetadata(
         x,
         metadata.path=file.path(path, "other_annotations"),
         mcols.path=file.path(path, "element_annotations"),
         ...
    )

    fpath <- file.path(path, "partitions.h5")
    fhandle <- H5Fcreate(fpath, "H5F_ACC_TRUNC")
    on.exit(H5Fclose(fhandle), add=TRUE, after=FALSE)

    ghandle <- H5Gcreate(fhandle, name)
    on.exit(H5Gclose(ghandle), add=TRUE, after=FALSE)

    h5_write_vector(ghandle, "lengths", lengths(x), type="H5T_NATIVE_UINT32")
    if (!is.null(names(x))) {
        h5_write_vector(ghandle, "names", names(x))
    }

    extras <- list(list(version="1.0"))
    names(extras) <- name
    saveObjectFile(path, name, extras)

    invisible(NULL)
}

##############################
######### OLD STUFF ##########
##############################

#' @export
#' @import S4Vectors
setMethod("stageObject", "CompressedAtomicList", function(x, dir, path, child=FALSE, group.name="grouping", concat.name="concatenated", mcols.name="mcols", meta.name="other") {
    rd <- DataFrame(values=unlist(x, use.names=FALSE))
    .compressed_stager(x, 
        concatenated=rd, 
        schema="atomic_vector_list/v1.json",
        dir=dir, 
        path=path, 
        child=child,
        group.name=group.name, 
        concat.name=concat.name, 
        mcols.name=mcols.name,
        meta.name=meta.name
    )
})

.compressed_stager <- function(x, concatenated, schema, dir, path, group.name, concat.name, mcols.name, meta.name, extra.args=list(), child=FALSE) {
    dir.create(file.path(dir, path))

    cat.args <- c(list(concatenated, dir, file.path(path, concat.name), child=TRUE), extra.args)
    cat.info <- tryCatch({ 
        info <- do.call(.stageObject, cat.args)
        .writeMetadata(info, dir)
    }, error=function(e) {
        stop("failed to stage 'unlist(<", class(x)[1], ">)'\n  - ", e$message)
    })

    path2 <- file.path(path, paste0(group.name, ".csv.gz"))
    ofile <- file.path(dir, path2)
    rd <- data.frame(number=lengths(x))
    if (!is.null(names(x))){ 
        rd <- cbind(row_names=names(x), rd)
    }
    .quickWriteCsv(rd, path=ofile)

    # Automatically returns NULL if it's the names are NULL.
    element_data <- .processMcols(x, dir, path, mcols.name)
    other_data <- .processMetadata(x, dir, path, meta.name)

    meta <- list(
        `$schema`=schema,
        path=path2, 
        is_child=child,
        compressed_list=list(
            length=length(x),
            names=!is.null(names(x)),
            element_data=element_data,
            other_data=other_data,
            compression="gzip"
        )
    )

    meta[[dirname(schema)]] <- list(concatenated=list(resource=cat.info))

    meta
}

#' Load an atomic vector list
#'
#' Load a list of atomic vectors as a \linkS4class{CompressedAtomicList} from its on-disk representation.
#' This is usually not directly called by users, but is instead called by dispatch in \code{\link{readObject}}.
#'
#' @param path String containing a path to a directory, itself created with the \code{\link{saveObject}} method for \linkS4class{CompressedAtomicList}s.
#' @param metadata Named list of metadata for this object, see \code{\link{readObjectFile}} for details.
#' @param ... Further arguments, to be passed to internal \code{\link{altReadObject}} calls.
#'
#' @return A CompressedAtomicList of the relevant type.
#'
#' @seealso
#' \code{"\link{saveObject,CompressedAtomicList-method}"}, to save an object to disk.
#'
#' @author Aaron Lun
#'
#' @examples
#' library(S4Vectors)
#' X <- splitAsList(LETTERS, sample(3, 26, replace=TRUE))
#'
#' tmp <- tempfile()
#' saveObject(X, tmp)
#' readObject(tmp)
#'
#' @export
#' @aliases loadAtomicVectorList
readAtomicVectorList <- function(path, metadata, ...) {
    .read_compressed_list(path, metadata, "atomic_vector_list", ...)
}

#' @import BiocGenerics IRanges rhdf5 alabaster.base
.read_compressed_list <- function(path, metadata, name, ...) {
    concat <- altReadObject(file.path(path, "concatenated"), ...)

    fpath <- file.path(path, "partitions.h5")
    fhandle <- H5Fopen(fpath, flags="H5F_ACC_RDONLY")
    on.exit(H5Fclose(fhandle), add=TRUE, after=FALSE)
    ghandle <- H5Gopen(fhandle, name)
    on.exit(H5Gclose(ghandle), add=TRUE, after=FALSE)

    runs <- h5_read_vector(ghandle, "lengths")
    output <- relist(concat, PartitioningByWidth(x=runs))
    if (h5_object_exists(ghandle, "names")) {
        names(output) <- h5_read_vector(ghandle, "names")
    }

    readMetadata(
        output, 
        mcols.path=file.path(path, "element_annotations"),
        metadata.path=file.path(path, "other_annotations"),
        ...
    )
}

##############################
######### OLD STUFF ##########
##############################

#' @export
loadAtomicVectorList <- function(info, project) {
    concat.info <- acquireMetadata(project, info$atomic_vector_list$concatenated$resource$path)
    concat <- .loadObject(concat.info, project=project)
    unlisted <- concat[,1]
    names(unlisted) <- rownames(concat)
    .load_compressed(unlisted, info, project)
}

#' @importFrom BiocGenerics relist
#' @importFrom IRanges PartitioningByWidth
.load_compressed <- function(contents, info, project) {
    path <- acquireFile(project, info$path)

    has.names <- isTRUE(info$compressed_list$names)
    groups <- .quickReadCsv(path, 
        c(number="integer"), 
        row.names=has.names,
        compression=info$compressed_list$compression,
        expected.nrows=info$compressed_list$length
    )

    runs <- groups[,1]
    if (has.names) {
        names(runs) <- rownames(groups)
    }

    output <- relist(contents, PartitioningByWidth(x=runs))
    .restoreMetadata(output, mcol.data=info$compressed_list$element_data, meta.data=info$compressed_list$other_data, project=project)
}

#' Save a GRangesList object to disk
#'
#' Save a \linkS4class{GRangesList} object to its on-disk representation.
#' 
#' @param x A \linkS4class{GRangesList} object. 
#' @inheritParams alabaster.base::saveObject
#'
#' @return 
#' \code{x} is saved to \code{path}, and \code{NULL} is invisibly returned.
#'
#' @seealso
#' \code{\link{readGRangesList}}, to read a \linkS4class{GRangesList} from disk.
#'
#' @examples
#' gr <- GRanges("chrA", IRanges(1:100, width=1))
#' grl <- split(gr, rep(1:3, length.out=length(gr)))
#'
#' tmp <- tempfile()
#' saveObject(grl, tmp)
#' list.files(tmp, recursive=TRUE)
#'
#' @author Aaron Lun
#' 
#' @export
#' @aliases stageObject,GRangesList-method
#' @rdname saveGRangesList
setMethod("saveObject", "GRangesList", function(x, path, ...) .save_compressed_list(x, path=path, name="genomic_ranges_list", ...))

##############################
######### OLD STUFF ##########
##############################

#' @export
setMethod("stageObject", "GRangesList", function(x, dir, path, child=FALSE, group.name="grouping", mcols.name="mcols", ranges.name="ranges", meta.name="other", ranges.args=list()) {
    .compressed_stager(x, 
        concatenated=unlist(x, use.names=FALSE),
        schema="genomic_ranges_list/v1.json",
        dir=dir, 
        path=path, 
        child=child,
        group.name=group.name, 
        concat.name=ranges.name, 
        mcols.name=mcols.name,
        meta.name=meta.name,
        extra.args=ranges.args)
})

#' Read a Seqinfo from disk
#'
#' Read a \linkS4class{Seqinfo} object from its on-disk representation.
#' This is usually not directly called by users, but is instead called by dispatch in \code{\link{readObject}}.
#' 
#' @param path String containing a path to a directory, itself created with the \code{\link{saveObject}} method for Seqinfo objects.
#' @param metadata Named list of metadata for this object, see \code{\link{readObjectFile}} for details.
#' @param ... Further arguments, ignored.
#'
#' @return A \linkS4class{Seqinfo} object.
#' @seealso
#' \code{"\link{saveObject,Seqinfo-method}"} for the corresponding saving method.
#'
#' @examples
#' si <- Seqinfo(c("chrA", "chrB"), c(1000, 2000))
#'
#' tmp <- tempfile()
#' saveObject(si, tmp)
#' readObject(tmp)
#' 
#' @export
#' @aliases loadSeqinfo
#' @import rhdf5 alabaster.base
readSeqinfo <- function(path, metadata, ...) {
    fpath <- file.path(path, "info.h5")

    fhandle <- H5Fopen(fpath, flags="H5F_ACC_RDONLY")
    on.exit(H5Fclose(fhandle), add=TRUE, after=FALSE)

    name <- "sequence_information"
    ghandle <- H5Gopen(fhandle, name)
    on.exit(H5Gclose(ghandle), add=TRUE, after=FALSE)

    seqnames <- h5_read_vector(ghandle, "name")

    genome <- local({
        dhandle <- H5Dopen(ghandle, "genome")
        on.exit(H5Dclose(dhandle), add=TRUE, after=FALSE)
        contents <- H5Dread(dhandle, drop=TRUE)
        missing.placeholder <- h5_read_attribute(dhandle, missingPlaceholderName, check=TRUE, default=NULL)
        h5_cast(contents, expected.type="string", missing.placeholder=missing.placeholder)
    })

    circular <- local({ 
        dhandle <- H5Dopen(ghandle, "circular")
        on.exit(H5Dclose(dhandle), add=TRUE, after=FALSE)
        contents <- H5Dread(dhandle, drop=TRUE)
        missing.placeholder <- h5_read_attribute(dhandle, missingPlaceholderName, check=TRUE, default=NULL)
        h5_cast(contents, expected.type="boolean", missing.placeholder=missing.placeholder)
    })

    seqlengths <- local({
        dhandle <- H5Dopen(ghandle, "length")
        on.exit(H5Dclose(dhandle), add=TRUE, after=FALSE)
        contents <- H5Dread(dhandle, bit64conversion="double", drop=TRUE)
        missing.placeholder <- h5_read_attribute(dhandle, missingPlaceholderName, check=TRUE, default=NULL, bit64conversion="double")
        h5_cast(contents, expected.type="integer", missing.placeholder=missing.placeholder)
    })

    Seqinfo(seqnames=seqnames, seqlengths=seqlengths, isCircular=circular, genome=genome)
}

##############################
######### OLD STUFF ##########
##############################

#' @export
loadSeqinfo <- function(info, project) {
    si.path <- acquireFile(project, info$path)
    si.df <- .quickReadCsv(si.path, 
        c(seqnames="character", seqlengths="integer", isCircular="logical", genome="character"), 
        row.names=FALSE,
        compression=info$sequence_information$compression, 
        expected.nrows=info$sequence_information$dimensions[[1]]
    )
    Seqinfo(
        seqnames=as.character(si.df$seqnames), 
        seqlengths=as.integer(si.df$seqlengths), 
        isCircular=as.logical(si.df$isCircular), 
        genome=as.character(si.df$genome)
    )
}

# Test stageObject on various bits and pieces.
# library(testthat); library(alabaster.ranges); source('setup.R'); source("test-Seqinfo.R")

SI <- Seqinfo(c("chrA", "chrB", "chrC"), c(1000, 20000, 300))

test_that("stageObject works correctly", {
    tmp <- tempfile()
    dir.create(tmp)
    out <- stageObject(SI, tmp, "thing")

    rr <- read.csv(file.path(tmp, out$path), row.names=1)
    expect_identical(rownames(rr), seqnames(SI))
    expect_identical(rr$seqlengths, unname(seqlengths(SI)))

    # Metadata is saved properly.
    expect_false(is.null(out$sequence_information))
    expect_identical(out$sequence_information$compression, "gzip")

    # Round trip works.
    si2 <- loadSeqinfo(out, tmp)
    expect_identical(SI, si2)
})

test_that("stageObject works correctly in the new world", {
    SI <- Seqinfo(c("chrA", "chrB", "chrC"), c(1000, 20000, 300))
    tmp <- tempfile()
    out <- saveObject(SI, tmp)
    si2 <- readObject(tmp)
    expect_identical(SI, si2)

    # Missing sequence lengths. 
    SI <- Seqinfo(c("chrA", "chrB", "chrC"))
    tmp <- tempfile()
    out <- saveObject(SI, tmp)
    si2 <- readObject(tmp)
    expect_identical(SI, si2)

    # Adding all details.
    SI <- Seqinfo(c("chrA", "chrB", "chrC"), c(99, 999, 9999), genome=c("mm10", "hg38", "z10"), isCircular=c(TRUE, FALSE, FALSE))
    tmp <- tempfile()
    out <- saveObject(SI, tmp)
    si2 <- readObject(tmp)
    expect_identical(SI, si2)
})

#' Read a GRanges from disk
#'
#' Read a \linkS4class{GRanges} object from its on-disk representation.
#' This is usually not directly called by users, but is instead called by dispatch in \code{\link{readObject}}.
#' 
#' @param path String containing a path to a directory, itself created with the \code{\link{stageObject}} method for \linkS4class{GRanges}.
#' @param metadata Named list of metadata for this object, see \code{\link{readObjectFile}} for details.
#' @param ... Further arguments to pass to internal \code{\link{altReadObject}} calls.
#'
#' @return A \linkS4class{GRanges} object.
#'
#' @seealso
#' \code{"\link{saveObject,GRanges-method}"}, to save a \linkS4class{GRanges} to disk.
#'
#' @author Aaron Lun
#'
#' @examples
#' gr <- GRanges(c("chrA", "chrB"), IRanges(c(1, 5), c(100, 200)))
#' seqlengths(gr) <- c(chrA=1000, chrB=2000)
#'
#' tmp <- tempfile()
#' saveObject(gr, tmp)
#' readObject(tmp)
#' 
#' @export
#' @aliases loadGRanges
#' @import rhdf5 alabaster.base IRanges GenomicRanges
readGRanges <- function(path, metadata, ...) {
    si <- altReadObject(file.path(path, "sequence_information"), ...)

    fpath <- file.path(path, "ranges.h5")
    fhandle <- H5Fopen(fpath, flags="H5F_ACC_RDONLY")
    on.exit(H5Fclose(fhandle), add=TRUE, after=FALSE)
    ghandle <- H5Gopen(fhandle, "genomic_ranges")
    on.exit(H5Gclose(ghandle), add=TRUE, after=FALSE)

    x <- GRanges(
        seqnames(si)[h5_read_vector(ghandle, "sequence") + 1L],
        IRanges(
            h5_read_vector(ghandle, "start"),
            width=h5_read_vector(ghandle, "width")
        ),
        c("-", "*", "+")[h5_read_vector(ghandle, "strand") + 2L],
        seqinfo=si
    )

    if (h5_object_exists(ghandle, "name")) {
        names(x) <- h5_read_vector(ghandle, "name")
    }

    readMetadata(x, 
        mcols.path=file.path(path, "range_annotations"),
        metadata.path=file.path(path, "other_annotations"),
        ...
    )
}

##############################
######### OLD STUFF ##########
##############################

#' @export
loadGRanges <- function(info, project) {
    # First, pulling out the seqinfo.
    si.info <- acquireMetadata(project, info$genomic_ranges$sequence_information$resource$path)
    SI <- .loadObject(si.info, project)

    # Convert the CSV into a GRanges.
    path <- acquireFile(project, info$path)
    gr.has.names <- isTRUE(info$genomic_ranges$names)

    rr.df <- .quickReadCsv(path, 
        expected.columns = c(seqnames="character", start="integer", end="integer", strand="character"),
        row.names = gr.has.names,
        compression = info$genomic_ranges$compression, 
        expected.nrows = info$genomic_ranges$length
    )

    rr <- GRanges(rr.df$seqnames, IRanges(rr.df$start, rr.df$end), strand=rr.df$strand, seqinfo=SI)
    if (gr.has.names) {
        names(rr) <- rownames(rr.df)
    } 

    .restoreMetadata(rr, mcol.data=info$genomic_ranges$range_data, meta.data=info$genomic_ranges$other_data, project=project)
}

# Test stageObject on various bits and pieces.
# library(testthat); library(alabaster.ranges); source("setup.R"); source("test-GRanges.R")

set.seed(1000)
gr <- GRanges(
    paste0('chr', sample(LETTERS[1:3], 100, replace=TRUE)),
    IRanges(sample(1000, 100), width=sample(100, 100, replace=TRUE)),
    strand=sample(c("+", "-", "*"), 100, replace=TRUE)
)
names(gr) <- paste0("Gene_", seq_along(gr))

test_that("stageObject works correctly", {
    tmp <- tempfile()
    dir.create(tmp)
    out <- stageObject(gr, tmp, "thing")

    rr <- read.csv(file.path(tmp, out$path), row.names=1)
    expect_identical(rownames(rr), names(gr))
    expect_identical(rr$seqnames, as.character(seqnames(gr)))
    expect_identical(rr$start, start(gr))
    expect_identical(rr$end, end(gr))

    # Metadata is saved properly.
    expect_true(out$genomic_ranges$names)
    expect_null(out$genomic_ranges$range_data) # no mcols yet, see below.
    expect_null(out$genomic_ranges$other_data) # no metadata yet, see below.
    expect_identical(out$genomic_ranges$compression, "gzip")

    # Round trip works.
    gr2 <- loadGRanges(out, tmp)
    expect_identical(gr, gr2)

    # Works in the new world.
    tmp <- tempfile()
    saveObject(gr, tmp)
    gr2 <- readObject(tmp)
    expect_identical(gr, gr2)
})

test_that("stageObject handles non-trivial seqinfo", {
    seqlengths(gr) <- setNames(1000 * (1 + runif(length(seqlengths(gr)))), seqlevels(gr))

    tmp <- tempfile()
    dir.create(tmp)
    out <- stageObject(gr, tmp, "thing")

    # Sequencing information is saved properly.
    si <- read.csv(file.path(tmp, out$genomic_ranges$sequence_information$resource$path), row.names=1)
    expect_identical(setNames(si$seqlengths, rownames(si)), seqlengths(gr))

    # Round trip works.
    gr2 <- loadGRanges(out, tmp)
    expect_identical(gr, gr2)

    # Works in the new world.
    tmp <- tempfile()
    saveObject(gr, tmp)
    gr2 <- readObject(tmp)
    expect_identical(gr, gr2)
})

test_that("stageObject works without names", {
    names(gr) <- NULL

    tmp <- tempfile()
    dir.create(tmp)
    out <- stageObject(gr, tmp, "thing")
    expect_false(out$genomic_ranges$names)

    gr2 <- loadGRanges(out, tmp)
    expect_identical(gr, gr2)

    # Works in the new world.
    tmp <- tempfile()
    saveObject(gr, tmp)
    gr2 <- readObject(tmp)
    expect_identical(gr, gr2)
})

test_that("stageObject works with extra mcols", {
    gr$stuff <- runif(length(gr))
    gr$foo <- sample(LETTERS, length(gr), replace=TRUE)

    tmp <- tempfile()
    dir.create(tmp)
    out <- stageObject(gr, tmp, "thing")
    expect_false(is.null(out$genomic_ranges$range_data))

    # Works in the new world.
    ntmp <- tempfile()
    saveObject(gr, ntmp)
    gr2 <- readObject(ntmp)
    expect_identical(gr, gr2)

    # Checking that they aren't present in the CSV.
    rr <- read.csv(file.path(tmp, out$path), row.names=1)
    expect_null(rr$stuff)
    expect_null(rr$foo)

    gr2 <- loadGRanges(out, tmp)
    expect_equal(gr, gr2)

    # Ignoring them.
    out <- stageObject(gr, tmp, "nomcols", mcols.name=NULL)
    expect_null(out$genomic_ranges$range_data)

    gr3 <- loadGRanges(out, tmp)
    expect_identical(ncol(mcols(gr3)), 0L)
})

test_that("stageObject works with extra metadata", {
    metadata(gr) <- list(WHEE="foo")

    tmp <- tempfile()
    dir.create(tmp)
    out <- stageObject(gr, tmp, "thing")
    expect_false(is.null(out$genomic_ranges$other_data))

    gr2 <- loadGRanges(out, tmp)
    expect_equal(gr, gr2)

    # Works in the new world.
    ntmp <- tempfile()
    saveObject(gr, ntmp)
    gr2 <- readObject(ntmp)
    expect_identical(gr, gr2)

    # Ignoring them.
    out <- stageObject(gr, tmp, "nometa", meta.name=NULL)
    expect_null(out$genomic_ranges$other_data)

    gr3 <- loadGRanges(out, tmp)
    expect_identical(length(metadata(gr3)), 0L)
})

#' Save compressed lists of data frames to disk
#'
#' Save a \linkS4class{CompressedSplitDataFrameList} object to its on-disk representation.
#'
#' @param x A \linkS4class{CompressedSplitDataFrameList} object.
#' @inheritParams alabaster.base::saveObject
#'
#' @return 
#' \code{x} is saved to \code{path}, and \code{NULL} is invisibly returned.
#'
#' @seealso
#' \code{\link{readDataFrameList}}, to read a \linkS4class{CompressedSplitDataFrameList} from disk.
#'
#' @author Aaron Lun
#' @examples
#' library(S4Vectors)
#' Y <- splitAsList(DataFrame(Xxx=LETTERS, Yyy=1:26), sample(3, 26, replace=TRUE))
#'
#' tmp <- tempfile()
#' saveObject(Y, tmp)
#' list.files(tmp, recursive=TRUE)
#'
#' @export
#' @aliases stageObject,CompressedSplitDataFrameList-method
#' @rdname saveCompressedSplitDataFrameList
setMethod("saveObject", "CompressedSplitDataFrameList", function(x, path, ...) .save_compressed_list(x, path=path, name="data_frame_list", ...))

##############################
######### OLD STUFF ##########
##############################

#' @export
setMethod("stageObject", "CompressedSplitDataFrameList", function(x, dir, path, child=FALSE, group.name="grouping.csv", concat.name="concatenated", mcols.name="mcols", meta.name="other") {
    rd <- unlist(x, use.names=FALSE)
    .compressed_stager(x, 
        concatenated=rd, 
        schema="data_frame_list/v1.json",
        dir=dir, 
        path=path, 
        child=child,
        group.name=group.name, 
        concat.name=concat.name, 
        mcols.name=mcols.name,
        meta.name=meta.name
    )
})

#' Load a data frame list
#'
#' Load a list of data frames as a \linkS4class{CompressedSplitDataFrameList} from its on-disk representation.
#' This is usually not directly called by users, but is instead called by dispatch in \code{\link{readObject}}.
#'
#' @param path String containing a path to a directory, itself created with the \code{\link{saveObject}} method for \linkS4class{CompressedSplitDataFrameList} objects.
#' @param metadata Named list of metadata for this object, see \code{\link{readObjectFile}} for details.
#' @param ... Further arguments, to be passed to internal \code{\link{altReadObject}} calls.
#'
#' @return A CompressedSplitDataFrameList.
#'
#' @seealso
#' \code{"\link{saveObject,CompressedSplitDataFrameList-method}"}, to save an object to disk.
#'
#' @author Aaron Lun
#'
#' @examples
#' library(S4Vectors)
#' Y <- splitAsList(DataFrame(Xxx=LETTERS, Yyy=1:26), sample(3, 26, replace=TRUE))
#'
#' tmp <- tempfile()
#' saveObject(Y, tmp)
#' readObject(tmp)
#'
#' @export
#' @aliases loadDataFrameList
readDataFrameList <- function(path, metadata, ...) {
    .read_compressed_list(path, metadata, "data_frame_list", ...)
}

##############################
######### OLD STUFF ##########
##############################

#' @export
loadDataFrameList <- function(info, project) {
    concat.info <- acquireMetadata(project, info$data_frame_list$concatenated$resource$path)
    concat <- .loadObject(concat.info, project=project)
    .load_compressed(concat, info, project=project)
}

# Test stageObjects on various bits and pieces.
# library(testthat); library(alabaster.ranges); source("setup.R"); source("test-DataFrameList.R")

test_that("staging and loading of data frame lists work as expected", {
    tmp <- tempfile()
    dir.create(tmp)

    df <- DataFrame(alpha=letters, bravo=26:1)
    X <- splitAsList(df, sample(paste0("G", 1:3), 26, replace=TRUE))
    staged <- .validatedStage(X, tmp, path="test1")

    expect_true(file.exists(file.path(tmp, staged$path)))
    expect_true(file.exists(file.path(tmp, staged$data_frame_list$concatenated$resource$path)))
    expect_identical(staged$compressed_list$compression, "gzip")

    Y <- loadDataFrameList(staged, project=tmp)
    expect_identical(X, Y)

    # Try with and without names.
    rownames(df) <- paste0("ROW", 1:nrow(df))
    X2 <- splitAsList(df, sample(3, 26, replace=TRUE))
    staged <- .validatedStage(X2, tmp, path="test2")
    Y2 <- loadDataFrameList(staged, project=tmp)
    expect_identical(X2, Y2)

    # Try with and without names.
    X3 <- X
    names(X3) <- NULL
    staged <- .validatedStage(X3, tmp, path="test3")
    Y3 <- loadDataFrameList(staged, project=tmp)
    expect_identical(X3, Y3)
})

test_that("staging and loading of data frame lists work in the new world", {
    df <- DataFrame(alpha=letters, bravo=26:1)
    X <- splitAsList(df, sample(paste0("G", 1:3), 26, replace=TRUE))

    tmp <- tempfile()
    saveObject(X, tmp)
    Y <- readObject(tmp)
    expect_identical(X, Y)

    # Try with inner names.
    rownames(df) <- paste0("ROW", 1:nrow(df))
    X2 <- splitAsList(df, sample(3, 26, replace=TRUE))

    tmp <- tempfile()
    saveObject(X2, tmp)
    Y <- readObject(tmp)
    expect_identical(X2, Y)

    # Try without outer names.
    X3 <- X
    names(X3) <- NULL

    tmp <- tempfile()
    saveObject(X3, tmp)
    Y <- readObject(tmp)
    expect_identical(X3, Y)

    # Slapping on some metadata.
    X4 <- X
    metadata(X4) <- list(WHEE="foo")
    mcols(X4)$info <- runif(length(X))

    tmp <- tempfile()
    saveObject(X4, tmp)
    Y <- readObject(tmp)
    expect_identical(X4, Y)
})

#' Save a Seqinfo object to disk
#'
#' Save a \linkS4class{Seqinfo} object to its on-disk representation.
#'
#' @param x A \linkS4class{Seqinfo} object. 
#' @inheritParams alabaster.base::saveObject
#'
#' @return 
#' \code{x} is saved to \code{path}, and \code{NULL} is invisibly returned.
#'
#' @seealso
#' \code{\link{readSeqinfo}}, to read a \linkS4class{Seqinfo} from disk.
#'
#' @examples
#' si <- Seqinfo(c("chrA", "chrB"), c(1000, 2000))
#'
#' tmp <- tempfile()
#' dir.create(tmp)
#' saveObject(si, tmp, path="seqinfo")
#' list.files(tmp, recursive=TRUE)
#'
#' @export
#' @aliases stageObject,Seqinfo-method
#' @rdname saveSeqinfo
#' @import rhdf5 alabaster.base GenomeInfoDb
setMethod("saveObject", "Seqinfo", function(x, path, ...) {
    dir.create(path, showWarnings=FALSE)
    fpath <- file.path(path, "info.h5")
    fhandle <- H5Fcreate(fpath, "H5F_ACC_TRUNC")
    on.exit(H5Fclose(fhandle), add=TRUE, after=FALSE)

    name <- "sequence_information"
    ghandle <- H5Gcreate(fhandle, name)
    on.exit(H5Gclose(ghandle), add=TRUE, after=FALSE)
    h5_write_attribute(ghandle, "version", "1.0", scalar=TRUE)

    sq <- seqnames(x)
    if (anyNA(sq)) {
        stop("'seqnames(<", class(x)[1], ">)' should not be missing")
    }
    h5_write_vector(ghandle, "name", sq)

    trans <- transformVectorForHdf5(genome(x))
    local({
        dhandle <- h5_write_vector(ghandle, "genome", trans$transformed, emit=TRUE)
        on.exit(H5Dclose(dhandle), add=TRUE, after=FALSE)
        if (!is.null(trans$placeholder)) {
            h5_write_attribute(dhandle, missingPlaceholderName, trans$placeholder, scalar=TRUE)
        }
    })

    trans <- transformVectorForHdf5(isCircular(x))
    local({
        dhandle <- h5_write_vector(ghandle, "circular", trans$transformed, emit=TRUE)
        on.exit(H5Dclose(dhandle), add=TRUE, after=FALSE)
        if (!is.null(trans$placeholder)) {
            h5_write_attribute(dhandle, missingPlaceholderName, trans$placeholder, scalar=TRUE)
        }
    })

    ll <- seqlengths(x)
    placeholder <- NULL
    if (anyNA(ll)) {
        placeholder <- 2^32 - 1
        ll <- as.double(ll)
        ll[is.na(ll)] <- placeholder
    }
    local({
        dhandle <- h5_write_vector(ghandle, "length", ll, type="H5T_NATIVE_UINT32", emit=TRUE)
        on.exit(H5Dclose(dhandle), add=TRUE, after=FALSE)
        if (!is.null(placeholder)) {
            h5_write_attribute(dhandle, missingPlaceholderName, placeholder, type="H5T_NATIVE_UINT32", scalar=TRUE)
        }
    })

    saveObjectFile(path, name, list(sequence_information=list(version="1.0")))
    invisible(NULL)
})

##############################
######### OLD STUFF ##########
##############################

#' @export
setMethod("stageObject", "Seqinfo", function(x, dir, path, child=FALSE) {
    dir.create(file.path(dir, path), showWarnings=FALSE)

    si.path <- file.path(path, "simple.csv.gz")
    x <- as.data.frame(x)
    si <- cbind(seqnames=rownames(x), x)
    .quickWriteCsv(si, path=file.path(dir, si.path))

    list(
        `$schema`="sequence_information/v1.json",
        path=si.path,
        is_child=child,
        sequence_information=list(
            dimensions=dim(x),
            compression="gzip"
        )
    )
})

#' Save a GRanges object to disk
#'
#' Save a \linkS4class{GRanges} object to its on-disk representation .
#' 
#' @param x A \linkS4class{GRanges} object or one of its subclasses.
#' @inheritParams alabaster.base::saveObject
#'
#' @return 
#' \code{x} is saved to \code{path}, and \code{NULL} is invisibly returned.
#'
#' @seealso
#' \code{\link{readGRanges}}, to read a \linkS4class{GRanges} from disk.
#'
#' @examples
#' gr <- GRanges(c("chrA", "chrB"), IRanges(c(1, 5), c(100, 200)))
#' seqlengths(gr) <- c(chrA=1000, chrB=2000)
#'
#' tmp <- tempfile()
#' saveObject(gr, tmp)
#' list.files(tmp, recursive=TRUE)
#'
#' @author Aaron Lun
#' 
#' @export
#' @aliases stageObject,GRanges-method
#' @rdname saveGRanges
#' @import rhdf5 methods alabaster.base GenomicRanges
setMethod("saveObject", "GRanges", function(x, path, ...) {
    dir.create(path, showWarnings=FALSE)

    altSaveObject(seqinfo(x), file.path(path, "sequence_information"), ...)
    saveMetadata(
        x, 
        mcols.path=file.path(path, "range_annotations"),
        metadata.path=file.path(path, "other_annotations"), 
        ...
    )

    fpath <- file.path(path, "ranges.h5")
    fhandle <- H5Fcreate(fpath, "H5F_ACC_TRUNC")
    on.exit(H5Fclose(fhandle), add=TRUE, after=FALSE)

    name <- "genomic_ranges"
    ghandle <- H5Gcreate(fhandle, name)
    on.exit(H5Gclose(ghandle), add=TRUE, after=FALSE)

    seqcodes <- match(as.character(seqnames(x)), seqnames(seqinfo(x))) - 1L
    h5_write_vector(ghandle, "sequence", seqcodes, type="H5T_NATIVE_UINT32")
    h5_write_vector(ghandle, "start", start(x))
    h5_write_vector(ghandle, "width", width(x), type="H5T_NATIVE_UINT32")
    h5_write_vector(ghandle, "strand", match(as.character(strand(x)), c("-", "*", "+")) - 2L, type="H5T_NATIVE_INT8")

    if (!is.null(names(x))) {
        h5_write_vector(ghandle, "name", names(x))
    }

    saveObjectFile(path, name, list(genomic_ranges=list(version="1.0")))
    invisible(NULL)
})

##############################
######### OLD STUFF ##########
##############################

#' @export
setMethod("stageObject", "GRanges", function(x, dir, path, child=FALSE, coord.name="ranges", seqinfo.name="seqinfo", mcols.name="mcols", meta.name="other") {
    dir.create(file.path(dir, path), showWarnings=FALSE)

    # Saving the sequence information.
    si.info <- tryCatch({
        meta <- .stageObject(seqinfo(x), dir, file.path(path, seqinfo.name), child=TRUE)
        .writeMetadata(dir=dir, meta)
    }, error=function(e) {
        stop("failed to stage 'seqinfo(<", class(x)[1], ">)'\n  - ", e$message)
    })

    # Saving other metadata. This automatically returns NULL if the names are NULL.
    range_data <- .processMcols(x, dir, path, mcols.name)
    other_data <- .processMetadata(x, dir, path, meta.name)

    # Saving the GRanges (removing the metadata first, otherwise we'd get extra columns).
    mcols(x) <- NULL

    df <- as.data.frame(x)
    if (!is.character(df$seqnames) && !is.factor(df$seqnames)) {
        stop("'seqnames' from 'as.data.frame(<GRanges>)' should be a character vector or factor")
    }
    if (!is.integer(df$start)) {
        stop("'start' from 'as.data.frame(<GRanges>)' should be an integer vector")
    }
    if (!is.integer(df$end)) {
        stop("'end' from 'as.data.frame(<GRanges>)' should be an integer vector")
    }
    if (!is.character(df$strand) && !is.factor(df$strand)) {
        stop("'strand' from 'as.data.frame(<GRanges>)' should be a character vector")
    }
    df <- df[,c("seqnames", "start", "end", "strand"),drop=FALSE] # protect against subclasses that add extra stuff.

    if (!is.null(names(x))) {
        df <- cbind(row_names=names(x), df)
    }
    gr.path <- file.path(path, paste0(coord.name, ".csv.gz"))
    gr.file <- file.path(dir, gr.path)
    .quickWriteCsv(df, path=gr.file)

    list(
        `$schema`="genomic_ranges/v1.json",
        path=gr.path,
        is_child=child,
        genomic_ranges=list(
            length=NROW(x),
            names=!is.null(names(x)),
            sequence_information=list(resource=si.info),
            range_data=range_data,
            other_data=other_data,
            compression="gzip"
        )
    )
})

---
title: Saving genomic ranges to artifacts and back again
author:
- name: Aaron Lun
  email: infinite.monkeys.with.keyboards@gmail.com
package: alabaster.ranges
date: "Revised: November 20, 2023"
output:
  BiocStyle::html_document
vignette: >
  %\VignetteIndexEntry{Saving and loading genomic ranges}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, echo=FALSE}
library(BiocStyle)
self <- Biocpkg("alabaster.ranges")
knitr::opts_chunk$set(error=FALSE, warning=FALSE, message=FALSE)
```

# Overview 

The `r self` package implements methods to save genomic ranges (i.e., `GRanges` and `GRangesList` objects) to file artifacts and load them back into R.
It also supports various `CompressedList` subclasses, including the somewhat useful `CompressedSplitDataFrameList`.
Check out `r Biocpkg("alabaster.base")` for more details on the motivation and concepts of the **alabaster** framework.

# Quick start

Given some genomic ranges, we can use `saveObject()` to save it inside a staging directory:

```{r}
library(GenomicRanges)
gr <- GRanges("chrA", IRanges(sample(100), width=sample(100)))
mcols(gr)$score <- runif(length(gr))
metadata(gr)$genome <- "Aaron"
seqlengths(gr) <- c(chrA=1000)

library(alabaster.ranges)
tmp <- tempfile()
saveObject(gr, tmp)

list.files(tmp, recursive=TRUE)
```

We can then easily load it back in with `readObject()`.

```{r}
roundtrip <- readObject(tmp)
roundtrip
```

The same can be done for `GRangesList` and `CompressedList` subclasses.

## Further comments 

Metadata is preserved during this round-trip:

```{r}
metadata(roundtrip)
mcols(roundtrip)
seqinfo(roundtrip)
```

# Session information {-}

```{r}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/saveGRangesList.R
\name{saveObject,GRangesList-method}
\alias{saveObject,GRangesList-method}
\alias{stageObject,GRangesList-method}
\title{Save a GRangesList object to disk}
\usage{
\S4method{saveObject}{GRangesList}(x, path, ...)
}
\arguments{
\item{x}{A \linkS4class{GRangesList} object.}

\item{path}{String containing the path to a directory in which to save \code{x}.}

\item{...}{Further arguments to pass to specific methods.}
}
\value{
\code{x} is saved to \code{path}, and \code{NULL} is invisibly returned.
}
\description{
Save a \linkS4class{GRangesList} object to its on-disk representation.
}
\examples{
gr <- GRanges("chrA", IRanges(1:100, width=1))
grl <- split(gr, rep(1:3, length.out=length(gr)))

tmp <- tempfile()
saveObject(grl, tmp)
list.files(tmp, recursive=TRUE)

}
\seealso{
\code{\link{readGRangesList}}, to read a \linkS4class{GRangesList} from disk.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readAtomicVectorList.R
\name{readAtomicVectorList}
\alias{readAtomicVectorList}
\alias{loadAtomicVectorList}
\title{Load an atomic vector list}
\usage{
readAtomicVectorList(path, metadata, ...)
}
\arguments{
\item{path}{String containing a path to a directory, itself created with the \code{\link{saveObject}} method for \linkS4class{CompressedAtomicList}s.}

\item{metadata}{Named list of metadata for this object, see \code{\link{readObjectFile}} for details.}

\item{...}{Further arguments, to be passed to internal \code{\link{altReadObject}} calls.}
}
\value{
A CompressedAtomicList of the relevant type.
}
\description{
Load a list of atomic vectors as a \linkS4class{CompressedAtomicList} from its on-disk representation.
This is usually not directly called by users, but is instead called by dispatch in \code{\link{readObject}}.
}
\examples{
library(S4Vectors)
X <- splitAsList(LETTERS, sample(3, 26, replace=TRUE))

tmp <- tempfile()
saveObject(X, tmp)
readObject(tmp)

}
\seealso{
\code{"\link{saveObject,CompressedAtomicList-method}"}, to save an object to disk.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readGRangesList.R
\name{readGRangesList}
\alias{readGRangesList}
\alias{loadGRangesList}
\title{Read a GRangesList from disk}
\usage{
readGRangesList(path, metadata, ...)
}
\arguments{
\item{path}{String containing a path to a directory, itself created with the \code{\link{saveObject}} method for \linkS4class{GRangesList}s.}

\item{metadata}{Named list of metadata for this object, see \code{\link{readObjectFile}} for details.}

\item{...}{Further arguments, to be passed to internal \code{\link{altReadObject}} calls.}
}
\value{
A \linkS4class{GRangesList} object.
}
\description{
Read a \linkS4class{GRangesList} object from its on-disk representation.
}
\examples{
gr <- GRanges(c("chrA", "chrB"), IRanges(c(1, 5), c(100, 200)))
seqlengths(gr) <- c(chrA=1000, chrB=2000)
grl <- split(gr, rep(1:3, length.out=length(gr)))

tmp <- tempfile()
saveObject(grl, tmp)
readObject(tmp)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/saveGRanges.R
\name{saveObject,GRanges-method}
\alias{saveObject,GRanges-method}
\alias{stageObject,GRanges-method}
\title{Save a GRanges object to disk}
\usage{
\S4method{saveObject}{GRanges}(x, path, ...)
}
\arguments{
\item{x}{A \linkS4class{GRanges} object or one of its subclasses.}

\item{path}{String containing the path to a directory in which to save \code{x}.}

\item{...}{Further arguments to pass to specific methods.}
}
\value{
\code{x} is saved to \code{path}, and \code{NULL} is invisibly returned.
}
\description{
Save a \linkS4class{GRanges} object to its on-disk representation .
}
\examples{
gr <- GRanges(c("chrA", "chrB"), IRanges(c(1, 5), c(100, 200)))
seqlengths(gr) <- c(chrA=1000, chrB=2000)

tmp <- tempfile()
saveObject(gr, tmp)
list.files(tmp, recursive=TRUE)

}
\seealso{
\code{\link{readGRanges}}, to read a \linkS4class{GRanges} from disk.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readSeqinfo.R
\name{readSeqinfo}
\alias{readSeqinfo}
\alias{loadSeqinfo}
\title{Read a Seqinfo from disk}
\usage{
readSeqinfo(path, metadata, ...)
}
\arguments{
\item{path}{String containing a path to a directory, itself created with the \code{\link{saveObject}} method for Seqinfo objects.}

\item{metadata}{Named list of metadata for this object, see \code{\link{readObjectFile}} for details.}

\item{...}{Further arguments, ignored.}
}
\value{
A \linkS4class{Seqinfo} object.
}
\description{
Read a \linkS4class{Seqinfo} object from its on-disk representation.
This is usually not directly called by users, but is instead called by dispatch in \code{\link{readObject}}.
}
\examples{
si <- Seqinfo(c("chrA", "chrB"), c(1000, 2000))

tmp <- tempfile()
saveObject(si, tmp)
readObject(tmp)

}
\seealso{
\code{"\link{saveObject,Seqinfo-method}"} for the corresponding saving method.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/saveSeqinfo.R
\name{saveObject,Seqinfo-method}
\alias{saveObject,Seqinfo-method}
\alias{stageObject,Seqinfo-method}
\title{Save a Seqinfo object to disk}
\usage{
\S4method{saveObject}{Seqinfo}(x, path, ...)
}
\arguments{
\item{x}{A \linkS4class{Seqinfo} object.}

\item{path}{String containing the path to a directory in which to save \code{x}.}

\item{...}{Further arguments to pass to specific methods.}
}
\value{
\code{x} is saved to \code{path}, and \code{NULL} is invisibly returned.
}
\description{
Save a \linkS4class{Seqinfo} object to its on-disk representation.
}
\examples{
si <- Seqinfo(c("chrA", "chrB"), c(1000, 2000))

tmp <- tempfile()
dir.create(tmp)
saveObject(si, tmp, path="seqinfo")
list.files(tmp, recursive=TRUE)

}
\seealso{
\code{\link{readSeqinfo}}, to read a \linkS4class{Seqinfo} from disk.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readGRanges.R
\name{readGRanges}
\alias{readGRanges}
\alias{loadGRanges}
\title{Read a GRanges from disk}
\usage{
readGRanges(path, metadata, ...)
}
\arguments{
\item{path}{String containing a path to a directory, itself created with the \code{\link{stageObject}} method for \linkS4class{GRanges}.}

\item{metadata}{Named list of metadata for this object, see \code{\link{readObjectFile}} for details.}

\item{...}{Further arguments to pass to internal \code{\link{altReadObject}} calls.}
}
\value{
A \linkS4class{GRanges} object.
}
\description{
Read a \linkS4class{GRanges} object from its on-disk representation.
This is usually not directly called by users, but is instead called by dispatch in \code{\link{readObject}}.
}
\examples{
gr <- GRanges(c("chrA", "chrB"), IRanges(c(1, 5), c(100, 200)))
seqlengths(gr) <- c(chrA=1000, chrB=2000)

tmp <- tempfile()
saveObject(gr, tmp)
readObject(tmp)

}
\seealso{
\code{"\link{saveObject,GRanges-method}"}, to save a \linkS4class{GRanges} to disk.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readDataFrameList.R
\name{readDataFrameList}
\alias{readDataFrameList}
\alias{loadDataFrameList}
\title{Load a data frame list}
\usage{
readDataFrameList(path, metadata, ...)
}
\arguments{
\item{path}{String containing a path to a directory, itself created with the \code{\link{saveObject}} method for \linkS4class{CompressedSplitDataFrameList} objects.}

\item{metadata}{Named list of metadata for this object, see \code{\link{readObjectFile}} for details.}

\item{...}{Further arguments, to be passed to internal \code{\link{altReadObject}} calls.}
}
\value{
A CompressedSplitDataFrameList.
}
\description{
Load a list of data frames as a \linkS4class{CompressedSplitDataFrameList} from its on-disk representation.
This is usually not directly called by users, but is instead called by dispatch in \code{\link{readObject}}.
}
\examples{
library(S4Vectors)
Y <- splitAsList(DataFrame(Xxx=LETTERS, Yyy=1:26), sample(3, 26, replace=TRUE))

tmp <- tempfile()
saveObject(Y, tmp)
readObject(tmp)

}
\seealso{
\code{"\link{saveObject,CompressedSplitDataFrameList-method}"}, to save an object to disk.
}
\author{
Aaron Lun
}
